﻿/*
 * C. Aubert
 * 2018_03_25
 * Project 2 - Problem #1
 * Daily Pay
 *
 * This is a possible solution, many other answers were valid.
 * 
 * However, the following were considered as mistakes:
 * - No name, date, or number of the problem solved in a delimited comment at the very beginning,
 * - Not performing user input validation (the user should be forced to give a positive number),
 * - Not using decimal for monetary amounts,
 * - Not using String.Format to format the output,
 * - Not using format specifier for monetary amounts.
 * 
 */
 */

using System;

class Program {
 static void Main() {

  // We declare variable to store the daily pay, the total pay, using decimal, since they will contain monetary amounts.
  // We set them to 0.1, the initial daily pay, and 0, since the user did not earned anything yet.
  decimal daily_pay = 0.01M;
  decimal pay = 0M;

  /*
   * Other variables needed are 
   * - a string to store the value entered by the user,
   * - a boolean to store whenever the user entered a number or not,
   * - an integer to store the number of days worked by the user,
   * - a counter to go through the loop and count how many days we computed.
   */

  string inputted_value;
  bool inputted_numerical_value;
  int days_worked;
  int counter = 1;


  // Part where we ask the user for a value, store it, and test that it is valid.
  // We use a "do ... while" loop to avoid having to duplicate parts of the code.
  do {
   Console.WriteLine("How many days did you work?");
   inputted_value = Console.ReadLine();
   inputted_numerical_value = int.TryParse(inputted_value, out days_worked);
  } while (days_worked < 0 || !inputted_numerical_value); // The test is "while the user enter something that is not an integer, or something an integer that is negative, we loop".

  // We first display the header of our table, using String.format to make it nice.
  Console.WriteLine("|" + String.Format("{0, 10}", "Day") + " \t |" +
   String.Format("{0, 15}", "Daily Pay") + "\t |" +
   String.Format("{0, 20}", "Earned so far") + "\t |");

  for (int i = 0; i < 66; i++) Console.Write("-"); // It's ok if you don't understand this line. It is a shorthand to display 66 times the symbol "-".

  Console.WriteLine(); // We then display a new line.

  // The loop in itself, that is executed as many time as days worked by the user.
  // We upload the pay, daily pay and counterer as we go, and display the result nicely, using String.format.
  while (counter <= days_worked) {
   pay += daily_pay;
   Console.WriteLine("|" + String.Format("{0, 10}", counter) + " \t |" +
    String.Format("{0, 15:C}", daily_pay) + "\t |" +
    String.Format("{0, 20:C}", pay) + "\t |");
   daily_pay *= 2;
   counter++;
  }
 }
}
