﻿/*
 * C. Aubert
 * 2018_03_25
 * Project 2 - Problem #4
 * Grade Calculator
 *
 * This is a possible solution, many other answers were valid.
 * 
 * However, the following were considered as mistakes:
 * - No name, date, or number of the problem solved in a delimited comment at the very beginning,
 * - Not giving the user the possibility of entering any number of grades,
 * - Not computing the average for every type of exam,
 * - Having the wrong calculation for the average grade "so far".
 * 
 */

using System;

class Program {
 static void Main() {
 
  /*
   * For the quizzes (Q), the project (P), the in-class tests (T) and the finale (F), we need
   * - An accumulator (acc),
   * - The number of evaluation of that kind that took place (n),
   * - An average (a).
   * 
   * This gives us the following variables, all initialized to 0:
   */

  int accQ = 0, nQ = 0;
  int accP = 0, nP = 0;
  int accT = 0, nT = 0;
  int accF = 0, nF = 0;
  double aQ = 0, aP = 0, aT = 0, aF = 0;
  // aQ, aP and aT are the avegare for the quizzes, the projects and the test. No need to compute the average for the exam: there is only one exam, but we still include a aF variable for consistency in our program.

  double tot = 0.0;
  // tot is for the percent of possible points.

  int read;
  // We will use this variable to temporarily store the value entered by the user.

  bool skip = false;
  // We will use this flag to determine when to exit while loops (if some of the evaluations did not take place yet).

  // We now display the instructions:
  Console.WriteLine("For all the questions below, enter\n \t- your grade, or\n\t- \"0\" if you missed the evaluation, or\n\t- \"-1\" if that evaluation did not happened yet.");

  // Loop to collect the data for the quizzes, and then we compute the average for the quizzes.
  do {
   Console.WriteLine("What was your grade for quiz " + (nQ + 1) + "?");
   read = int.Parse(Console.ReadLine());
   if (read == -1) {
    skip = true;
   } // If the value entered is -1, we set skip to true, so that we exit the loop.
   else {
    accQ += read;
    nQ++;
   } // If the value entered is not -1, we increment our accumulator by the value entered, and increment the number of quizzes that took place by 1.
  } while (!skip && nQ < 5); // We quit if the user entered -1 or if the number of quizzes taken is 5.

  // If quizzes were actually taken, we compute the average, increment the total, and display the average for quizzes.
  if (nQ != 0) {
   aQ = accQ / ((double) nQ * 20);
   tot += 0.1;
   Console.WriteLine($"Your average for the quiz is {aQ:P}.");
  }

  skip = false; // We resest this counter to its original value.


  // Loop to collect the data for the projects, and then we compute the average for the projects.
  // It works pretty much as the part on quizzes, except that there are 3 projects.
  do {
   Console.WriteLine("What was your grade for project " + (nP + 1) + "?");
   read = int.Parse(Console.ReadLine());
   if (read == -1) {
    skip = true;
   } else {
    accP += read;
    nP++;
   }
  } while (!skip && nP < 3);

  if (nP != 0) {
   aP = accP / ((double) nP * 20);
   tot += 0.1;
   Console.WriteLine($"Your average for the project is {aP:P}.");
  }

  skip = false;

  // Loop to collect the data for the in-class tests, and then we compute the average for the in-class tests.
  // It works pretty much as the part on quizzes, except that there are 2 tests, and that they count for 40% of the grade.
  do {
   Console.WriteLine("What was your grade for in-class test " + (nT + 1) + "?");
   read = int.Parse(Console.ReadLine());
   if (read == -1) {
    skip = true;
   } else {
    accT += read;
    nT++;
   }
  } while (!skip && nT < 2);

  if (nT != 0) {
   aT = accT / ((double) nT * 100);
   tot += 0.4;
   Console.WriteLine($"Your average for the tests is {aT:P}.");
  }

  skip = false;

  // Asking and reading for the final.
  Console.WriteLine("What was your grade for the final?");
  read = int.Parse(Console.ReadLine());
  if (read != -1) {
   aF += (read / 100.0);
   nF++;
   tot += 0.4;
  } // If the final was taken, we update accordingly the average and number for the final, and the possible total.
  // Note that we do not use the nF variable in this program, but still declare and update it, to accomodate possible evolution of our program.

  // Finally, we compute the avegare, based on the coefficients (10%, 10%, 40%, 40%) and on the total possible points:
  double avg = (aQ * 0.1 + aP * 0.1 + aT * 0.4 + aF * 0.4) / tot;

  // We then display the average:
  Console.WriteLine($"Your average so far is {avg:P}.");

 }
}
