---
title: Principles of Computer Programming I -- CSCI 1301
subtitle: Spring 2019
author: Clément Aubert
lang: en
fontsize: 10pt
keywords:
- Computer Science
- Problem solving methods
- Syllabus
- Augusta University
- Bachelor of Science
documentclass: scrartcl
numbersections: true
papersize: letter
geometry: margin=1in
header-includes:
 - \newcommand{\website}{\href{http://spots.augusta.edu/caubert/pcp/}{spots.augusta.edu/caubert/pcp/}}
 - \usepackage{titling}
 - \makeatletter\def\@maketitle{\centering{\usekomafont{title}{\huge \@title\par}\vskip .3em \usekomafont{subtitle}{\@subtitle\par}\vskip .3em}}\makeatother
 - \addtokomafont{section}{\centering}
 - \usepackage{xcolor}
 - \definecolor{links}{HTML}{2e4683}
 - \hypersetup{colorlinks=true, allcolors=links}
 - \linespread{1.1}
 - \usepackage{lastpage}
 - \usepackage{fancyhdr}
 - \pagestyle{fancy}
 - \fancypagestyle{plain}{
        \lfoot{\website}
        \cfoot{}
        \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
        \lhead{}
        \rhead{}
        \renewcommand{\headrulewidth}{0pt}
    }
 - \lhead{\textbf{Syllabus}}
 - \rhead{\thetitle}
 - \lfoot{\website}
 - \cfoot{}
 - \rfoot{Page\ \thepage\ of\ \protect\pageref{LastPage}}
 - \renewcommand{\footrulewidth}{0.4pt}
 - \renewcommand{\headrulewidth}{0.4pt}
---

## Quick Facts {-}

- Class meets TR 8:30--9:45 [am]{.smallcaps} in [Algood Hall](https://map.concept3d.com?id=824&mrkIid=268016#!m/268016) E-152.
- Lab. meets TR 10:00--10:50 [am]{.smallcaps} (Section A) and 11:30 [am]{.smallcaps}--12:20 [pm]{.smallcaps} (Section B) in [Algood Hall](https://map.concept3d.com?id=824&mrkIid=268016#!m/268016) E-365.
- The instructor's contact and office hours are at <http://spots.augusta.edu/caubert/#contact>.
- You can download [this syllabus](index.pdf).
- For the detail of the planning and evaluations, refer to [the planned schedule](#schedule).

## Quick Links {-}

[Laboratory](lab/) • [Homeworks](#hw) <!--• [Snippets of code](#snippets)--> • [Shared Documents](#doc_shared) • [Planned schedule](#schedule) • [Shared Lecture Notes](https://drive.google.com/drive/folders/1hvoCgDC7Zzv7t2gk8KjrRk_NL1_KAdmk?usp=sharing)

* * *

# Presentation

## Course Description

A rigorous study of the principles of computer programming with emphasis on problem solving methods which result in correct, well-structured programs.
Other topics: an introduction to data representation, data types and control structures, functions, and structured data types.

## Learning Outcomes

Students who successfully complete this course should:

#. Perform standard program Input and program Output using the keyboard and the monitor.
#. Declare and use user-defined variables, and constants using the appropriate data types.
#. Declare, define, and call user-defined functions.
#. Write and evaluate expressions using arithmetic, relational and logical operators.
#. Control the flow of program execution using the appropriate sequential, selection, and repetition statements.
#. Define, create and manipulate arrays.
#. Process lists of values – defining, creating, traversing.
#. Understand and implement classes and objects.

<!--
Upon successful completion of this class, the student will:

1. Understand the fundamentals concepts of programming languages:
  - The existence of multiple paradigms
  - The role of compilation
  - What is the flow of control
  - Reading simple algorithms
2. Be able to write, compile and execute simple `C#` programs:
  - Use of Visual Studio's basic features (including debugging),
  - Perform standard Input / Output operations,
  - Declare and use user-defined variables and constants, using appropriate data-types,
  - Declare, define and call user-defined functions,
  - Write and evaluate expressions using arithmetic, relational and logical operators,
  - Define, create and manipulate arrays,
  - Understand and implement classes and objects.
-->

## Format and Procedures

This course has a lecture, and a laboratory, portion: both are required to succeed.
This class is an on-campus class. 
Lectures are devoted to general explanations of the concepts and ideas underlying the topic at stake.
Laboratory will be devoted to hands-on practise and experiments.

Homework assignments will assist the students in making sure they understand classes expectations and the content of the lecture, as well as to practice their coding and problem-solving skills.
The progression of the students will be regularly tested and assessed through quizzes, projects and tests.
Active and relevant participation during the lectures and laboratory sessions is appreciated.

## Teaching Philosophy

It is our mutual interest for you to succeed: I love to share knowledge and to expand it by helping students, and students want to gain a useful and agreeable experience that will prove valuable in their future endeavors. To this end, here is:

### What I'm expecting from you

- Check periodically your email account and read the email I send.
- Read this entire syllabus carefully.
- Participate actively in all class discussions.
- Do the homeworks wisely: read your notes before starting the homework assignment, make sure you understand it completely before considering it done.
- Come prepared and on time to classes, exams and quizzes.

### What you should expect from me:

- Clear and accessible lectures.
- Fair and impartial grading.
- Availability, during office hours, by appointment, and by email.
- Open hear to your suggestions to improve this class.
- Dedication to your success!

## Course Requirements

The following rules, inspired by my experience and dictated by the size of our group, will be enforced:

### General Rules

- Attendance is not mandatory. However, if you come to class, come on time, and stay until the end of the lecture: late arrival and early departure disturb the learning experience for everyone.
- No laptop or similar electronic device is allowed during the lectures. This policy will help you to [improve your grades](https://doi.org/10.1007/BF02940852), [increase memorization](https://doi.org/10.1177/0956797614524581) and [to be more respectful of your  fellow students](https://doi.org/10.1016/j.compedu.2012.10.003). <!-- As [Yale suggests](https://ctl.yale.edu/Using-Electronic-Devices-in-Class) -->
- You are responsible for all course material, whether or not you attend lectures or do the assigned reading or coursework.
- It is the student's responsibility to [initiate a withdrawal](https://www.augusta.edu/registrar/withdrawal.php) before [midterm](https://www.augusta.edu/registrar/calendar2018.php), but I [reserve the right to withdraw](http://catalog.augusta.edu/content.php?catoid=30&navoid=3543#Class_Attendance) a student that missed 10% of class time and half of the quizzes and tests.
- A student not withdrawn from a course who stops attending class (or who never attends class) is subject to receiving a grade of **WF** or **F**.
- All coursework is individual coursework.
- Any student missing the final exam without an documented excuse (brought to me or to [the dean of Student Life](https://www.augusta.edu/student-life/dean.php)) or who has not taken action to withdraw will receive a grade of **F**. In case of an documented emergency at the time of the final, the student may be allowed to receive a grade of **I**.
- No make up quizzes or exam will be allowed. In case of a documented excuse (cf. previous item), the weight of the missed exam or quiz can be placed onto the final's weight.
- Come to your section's laboratory.
If you want to change your section, find a  fellow student willing to switch with you and go to the [registrar's office](http://www.augusta.edu/registrar/). 
- Late arrival and early departure are tolerated, but do not expect me to go over instructions a second time for you, and do not disturb your fellow students with your questions.
- Quiet chat and mutual help are acceptable, sharing solutions is forbidden. For instance,
  - Is allowed:
     - Discussing general strategies and approaches
     - Helping a  fellow student debugging a program *by asking questions* ("*Don't you think there might be a problem line X?*")
  - Is forbidden:
     - Touching someone's else keyboard or taking notes while talking
     - Sharing files or projects

<!--
Patricial Johann writes:

> Keep in mind that, unless cheating has occurred, it is extremely unlikely that any two people will develop the same solution to any given problem.
> For this reason, I will ask you to speak with me if any of your solutions very closely resembles those of another person.
> But since conversations about suspected cheating are rarely pleasant, I strongly urge you to abide by this Collaboration Policy, thereby putting neither yourself nor me in the difficult position of having to have such a conversation.
-->

# Practical Information

## Lab Space

For this class, you will need to access a computer with Visual Studio installed on it.
You can either:

- Visit one of the [Computer Labs](https://www.augusta.edu/its/computers-printing.php) that are accessible to every student,
- Use the lab reserved for students enrolled in a CSCI / AIST / MS-IMS class, in [University Hall](https://map.concept3d.com/?id=824#!m/268018), room 131,
- Use your personnal computer. Instructions on how to install and configure the softwares will be given during lab, download codes will be accessible from <https://www.augusta.edu/its/software.php> or using your [onthehub](https://e5.onthehub.com/WebStore/ProductsByMajorVersionList.aspx?cmi_mnuMain=4751da70-dd3c-df11-b4ab-0030487d8897&ws=2020165a-723a-de11-b696-0030485a8df0&vsro=8) account.

## Getting Help

<!--
Mitchell Williams is the tutor for Computer Science. You can find him in the [Academic Success Center](https://www.augusta.edu/afa/success-center/) on the first floor of [University Hall](http://myatlascms.com/map/?id=824&mrkIid=144096),

- Tuesday: 11:30 [am]{.smallcaps}-2:00 [pm]{.smallcaps}
- Thursday: 11:30 [am]{.smallcaps}-2:00 [pm]{.smallcaps}
- Friday: 10:00 [am]{.smallcaps}-1:00 [pm]{.smallcaps}

-->

I should be your first point of contact for any question regarding the content of this class, but many other ressources are available:

- If you are food insecure, [you are not alone](https://www.wjbf.com/news/csra-news/nearly-36-percent-of-college-students-are-hungry/1644345243), and the [Open Paws Food Pantry](https://www.augusta.edu/student-affairs/open-paws.php) will help you.
- For tutoring resources, consult [Academic Success Center](https://www.augusta.edu/afa/success-center/tutoring.php) (or "ASC").
- The [Testing & Disability Services](https://www.augusta.edu/tds/) can help you--and me!--accommodate this class.
- The [Student Counseling & Psychological Services](http://www.augusta.edu/counseling/) (or "SCAPS") is here to assist students with a variety of personal, developmental, and mental health concerns.

Tutoring is available for Computer Science in the [Academic Success Center](https://www.augusta.edu/afa/success-center/) on the first floor of [University Hall](http://myatlascms.com/map/?id=824&mrkIid=144096),

- Monday: 10:30 [am]{.smallcaps}-11:30[am]{.smallcaps} and 3:00[pm]{.smallcaps}-5:00[pm]{.smallcaps}
- Tuesday: 3:00 [pm]{.smallcaps}-7:00 [pm]{.smallcaps}
- Thursday: 2:30 [pm]{.smallcaps}-5:00 [pm]{.smallcaps}
- Friday: 2:00 [pm]{.smallcaps}-5:00 [pm]{.smallcaps}

You can also schedule appointments at <https://augusta.campus.eab.com/>.
Bryana Vinson and Assya Sellak will be our "embedded tutors" this semester.

Our student assistant Tim Cuny is also available:

- via email, <uca.timc@gmail.com>,
- Wednesday 1:00-3:00[pm]{.smallcaps} in [University Hall](http://myatlascms.com/map/?id=824&mrkIid=144096) 113,
- during class and labs (except on Thursday 11:30 [am]{.smallcaps}--12:20 [pm]{.smallcaps}).

[Shared lecture notes](https://drive.google.com/drive/folders/1hvoCgDC7Zzv7t2gk8KjrRk_NL1_KAdmk?usp=sharing) are available, courtesy of Tim Cuny.

## ACM Club

There is an [A.C.M](https://www.acm.org/ "Association for Computing Machinery") club at Augusta University, that meets on Fridays in UH 129 and 131, from 12 to 3pm:

[![The AU ACM club meets Fridays in UH 129 and 131, from 12 to 3pm.](../../../../web/img/au_acm_flyer.jpg)](../../../general/club/2019_AU_ACM_Flyer.pdf)

It is the ideal place to get to meet fellow students, to work on exciting projects, and to learn more about various aspects of Computer Science and Information Technology.


## Grades

Students will be evaluated using four different types of evaluation:

#. Homework assignments will be given during the course of the semester: they are not expected to be handed back, and won't be graded, but quizzes (closed book and timed (± 10 min.)) with questions taken or inspired from those assignments and the lab will be given.

#. Projects will be carried at home or during laboratory.

#. There will be in-class exams, held during the regular class periods.

#. The final exam will take place during the [exam period](https://www.augusta.edu/registrar/grading.php).

Refer to the [planned schedule](#scheldule) for precise dates.

Your grade will be computed as follows:

|
---|---
Quizzes (×5) | 10%
Projects (×3) | 10%
In-class Tests (×2) | 40%
Final Exam | 40%

using the following course grade scale:

| | | | | |
|:---:|:---:|:---:|:---:|:---:|
Below 65 | 65--70 | 70--79 | 80--89 | 90--100 |
**F** | **D** | **C** | **B** | **A** |


## Planned Course Schedule {#schedule}


<!-- 
https://www.augusta.edu/registrar/calendar2018.php
https://www.augusta.edu/registrar/documents/spring2019examschedule.pdf
-->

| Week | Date | Note | Topic  |
|-----|----  |---------------- |------------------------|
| 1     | 01/07 | - | Syllabus, Introduction |
| 2     | 01/14 | 01/17: **Quiz** | Reserved Words and Variables |
| 3     | 01/21 | _01/21: MLK day_ | Datatypes and Operations | 
| 4     | 01/28 | 01/31: **Quiz** | Casting and Reading from the User |
| 5     | 02/04 | 02/08: **Project** | Intro to Object-Oriented Language |
| 6     | 02/11 | 02/14: **Exam** | Review Session |
| 7     | 02/18 | - | Advanced Methods |
| 8     | 02/25 | 02/28: **Quiz** _(and Midterm)_ | Control Structures -- Boolean |
| 9     | 03/04 | _03/07--08: Spring pause_ | `if` Statements  |
| 10    | 03/11 | 03/14: **Quiz** | `switch` Statement  |
| 11    | 03/18 | 03/22: **Project** | `while` Statements |
| 12    | 03/25 | 03/28: **Exam** | Review Session |
| 13    | 04/01 | - | `for` Statements | 
| 14    | 04/08 | _04/08--12: Spring break_ | Arrays |
| 15    | 04/15 | 04/18: **Quiz** |  Continued |
| 16    | 04/22 | 04/26: **Project** | Wrapping up |
| 17    | 04/29 | _05/01: end of class_ | - | 
| 18    | 05/06 |  05/08 (8--10[am]{.smallcaps}): **Final** | - |

*This schedule is subject to change and enhancements, but provide an indication of the pace, assignments, and major deadlines that you will need to plan for the semester.*

# Additional Material and Resources {#resources}

## Textbook

Textbook is optional, and can be accessed at <https://www.safaribooksonline.com/library/view/visual-c-how/9780134628820/> for Augusta University students.

[*Visual C# How to Program*](http://www.deitel.com/Books/C/VisualCHowtoProgram6e/tabid/3680/Default.aspx) (6th Edition) by Paul J. Deitel and Harvey Deitel, Pearson, 2016, ISBN-10: 0134601548

<!--
Book can be purchased through [JagStore](http://www.jagstore.net/buy_courselisting.asp), select

* `JAGSTORE - 2018 SPRING-AUGUSTA UNIVERSITY`
    * `CSCI-CSCI`
        * `1301`
            * `A-Aubert, Clement`
-->

If you were to pick the 5th Edition, be aware of that the 6th edition takes into account the [recent 6th specification of C#](https://docs.microsoft.com/en-us/dotnet/csharp/language-reference/language-specification/).
As a consequence, it uses [string interpolation](https://docs.microsoft.com/en-us/dotnet/csharp/language-reference/language-specification/expressions#interpolated-strings) instead of comma-separated list, it simplifies the use of the [`ToString`](https://msdn.microsoft.com/en-us/library/system.object.tostring(v=vs.110).aspx?cs-save-lang=1&cs-lang=csharp#code-snippet-1) method, and that it uses a different method to convert `String` to `Integers`.

## Online Resources

- [Code examples from the textbook](http://deitel.com/bookresources/vcsharphtp6/examples.zip)
- [Dr. Michael Dowell](http://spots.gru.edu/mdowell/)--who teaches [CSCI 1302--Principles of Computer Programming II](http://spots.gru.edu/mdowell/csci1302.html)--lists [some interresting resources for `C#`](http://spots.gru.edu/mdowell/Resources/CSharp.html).
- [Reese Library's Cyber Resource Center](http://guides.augusta.edu/friendly.php?s=cyber)
- You can compile really simple `C#` projects online at [tutorialspoint.com/compile_csharp_online.php](https://www.tutorialspoint.com/compile_csharp_online.php) or [repl.it](https://repl.it/languages/csharp).
- All the shortcuts for all the versions of Visual Studio are listed at <http://visualstudioshortcuts.com/>.


## Homework Assignments {#hw}

<!--

None at the moment.

Check the [schedule](#schedule) for more information.
-->
- [Homework #1](hw/01.pdf)
- [Homework #2](hw/02.pdf)
- [Homework #3](hw/03.pdf)
- [Homework #4](hw/04.pdf)
- [Homework #5](hw/05.pdf)
- [Homework #6](hw/06.pdf)


## Documents Shared in Class {#doc_shared}

<!--

None at the moment.

-->

| Date | Title | |
| - | - | - |
| 01/21 | Datatypes |  [Webpage](shared/datatypes/), [printable document](shared/datatypes/index.pdf), [editable document](shared/datatypes/index.docx) |
| 01/28 | Project 1 |  [Webpage](shared/project01/), [printable document](shared/project01/index.pdf), [editable document](shared/project01/index.docx) |
| 03/11 | Project #2 Guide | [Printable document](shared/project2.pdf) | 


<!--
| 09/25 | Study Guide | [Webpage](../../../general/study_guide), [printable document](../../../general/study_guide/index.pdf) |
-->

# Legal and Recommendations

## Academic Integrity

The University's [Student Code of Conduct](https://www.augusta.edu/student-life/conduct/index.php), the [student's manual](https://www.augusta.edu/student-life/documents/2018studentmanualnew.pdf), as well as the [academic regulations](http://catalog.augusta.edu/content.php?catoid=25&navoid=3206) and all [applicable policies](https://www.augusta.edu/its/policies/) are supposed to be known by the students and will be enforced.

Section 5.2, Academic Conduct of the [student's manual](https://www.augusta.edu/student-life/documents/2018studentmanualnew.pdf) defines precisely what kind of collaborations are acceptable.
As long as you don't lie, cheat, plagiarize, assist others or being assisted by others without authorization, we should not need any of that.
If you are unsure about whether or not certain kinds of collaboration are permissible, please ask me.

## Universal Design

I am committed to the founding principles of [Universal Design](https://en.wikipedia.org/wiki/Universal_design), and to make [my lecture accessible to every one](https://www.augusta.edu/tds/documents/testing_docs/falculityguide1.pdf).
Concretely, that means that I'm not requiring you to use a particular Operating System, that I always try to give the information repeatedly, and using multiple channels, that I am available over the phone, email, or in my office.
If you are registered with [Testing and Disability Services](https://www.augusta.edu/tds/), please see me at your earlier convenience to discuss accommodations.

## Campus Carry Legislation

Please be aware of the [USG guidance on House Bill 280](http://www.usg.edu/hb280).
Note that you **may not** carry a handgun if high school students are enrolled in the class, and that it is your responsibility to visit the registrar to determine whenever this is the case or not.

# Miscellaneous

 * Reservation of rights: I reserve the right to change this syllabus without limitation and without prior notice. If I do substantially modify any item or policy, I will notify you during a lecture, or send an e-mail to your `augusta.edu` e-mail account.
 * Download [a `pdf` version](index.pdf) of this page. 
 * Contact: [caubert@augusta.edu](mailto:caubert@augusta.edu)
 * Created with [debian](https://www.debian.org/), [pandoc](https://pandoc.org/) and [latex](https://www.latex-project.org/).
<!--,
 [HTML5](https://validator.w3.org/check/referer) and [CSS3](https://jigsaw.w3.org/css-validator/check/referer) valid,
https://stackoverflow.com/q/46982187/2657549
https://webmasters.stackexchange.com/q/109954/54133
-->
 * All my documents are under [Creative Commons Attribution 4.0 International License](http://creativecommons.org/licenses/by/4.0/). Sources are available upon motivated request.
 * You will need a `pdf` reader to consult some of the documents: I recommend choosing [an open-source `pdf` reader](https://pdfreaders.org/).
